#ifndef __xmmsConnection_h__
#define __xmmsConnection_h__

#include "xmmsIConnection.h"
#include "xmmsMedialib.h"
#include "xmmsCollections.h"
#include "xmmsPlaylists.h"
#include "xmmsPlayback.h"
#include <xmmsclient/xmmsclient++/client.h>
#include "xmmsclient-moz.h"

class xmmsConnection : public xmmsIConnection
{
public:
    NS_DECL_ISUPPORTS
    NS_DECL_XMMSICONNECTION

    xmmsConnection(const std::string& name);
    ~xmmsConnection();

protected:
    void teardown();

protected:
    Xmms::Client  mClient;
    xmmsMedialib  mMedialib;
    xmmsCollections  mCollections;
    xmmsPlaylists  mPlaylists;
    xmmsPlayback  mPlayback;
    xmmsSocketHandler* mSocketHandler;
};

#endif
